VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2955
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5850
   LinkTopic       =   "Form1"
   ScaleHeight     =   2955
   ScaleWidth      =   5850
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox errorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "0"
      Top             =   1080
      Width           =   3495
   End
   Begin VB.TextBox errorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0"
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   5
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'VB6 example to communicate with a LJTick-DAC using I2C.  For more advanced LJTDAC
'operations, see the VC6 example.
'
'To test, please attach your LJTick-DAC on the FIO2/3 block
'
'support@labjack.com
'Oct 13, 2010
'Revised January 04, 2011

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngErrorcode As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim strError As String * 256
    Dim lngError As Long
    Dim writeACKS As Double
    Dim expectedACKS As Double
    
    Dim numI2CBytesToWrite As Double
    Dim numI2CBytesToRead As Double
    Dim writeArray(128) As Byte
    Dim readArray(128) As Byte
    Dim i As Long

    
    On Error GoTo ErrorMessage
    
      
    'Open the LabJack.
    'lngErrorcode = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle) 'First found USB U3.
    'lngErrorcode = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle) 'First found USB UE9.
    'lngErrorcode = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle) 'Ethernet UE9.
    lngErrorcode = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle) 'Firstfound USB U6.
    
    txtHandle = Str(lngHandle)
    errorNumber = Str(lngErrorcode)
    'Convert the error code to a string.
    ErrorToString lngErrorcode, strError
    errorString = strError
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    '(U3 only)
    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngErrorcode = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'The address of the EEPROM on the LJTick-DAC is 0xA0.
    lngErrorcode = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chI2C_ADDRESS, 160, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'SCL is FIO2
    lngErrorcode = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chI2C_SCL_PIN_NUM, 2, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'SDA is FIO1
    lngErrorcode = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chI2C_SDA_PIN_NUM, 3, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'See description of low-level I2C function.
    lngErrorcode = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chI2C_OPTIONS, 0, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'See description of low-level I2C function.  0 is max speed of about 130 kHz.
    lngErrorcode = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chI2C_SPEED_ADJUST, 0, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Execute the requests on a single LabJack.
    lngErrorcode = GoOne(lngHandle)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    While lngError = 0
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    Wend
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Initial read of EEPROM bytes 0-3 in the user memory area.
    'We need a single I2C transmission that writes the address and then reads
    'the data.  That is, there needs to be an ack after writing the address,
    'not a stop condition.  To accomplish this, we use Add/Go/Get to combine
    'the write and read into a single low-level call.
    numI2CBytesToWrite = 1
    writeArray(0) = 0 'Memory address.  User area is 0-63.
    lngErrorcode = AddRequest_ByRef(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_WRITE, numI2CBytesToWrite, writeArray(0), 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    lngErrorcode = AddRequest(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_GET_ACKS, 0, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    numI2CBytesToRead = 4
    lngErrorcode = AddRequest_ByRef(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_READ, numI2CBytesToRead, readArray(0), 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Execute the requests.
    lngErrorcode = GoOne(lngHandle)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Get the result of the write just to check for an error.
    lngErrorcode = GetResult(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_WRITE, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get the write ACKs and compare to the expected value.  We expect bit 0 to be
    'the ACK of the last data byte progressing up to the ACK of the address
    'byte (data bytes only for Control firmware 1.43 and less).  So if n is the
    'number of data bytes, the ACKs value should be (2^(n+1))-1.
    writeACKS = 2 ^ (numI2CBytesToWrite + 1) - 1
    lngErrorcode = GetResult(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_GET_ACKS, writeACKS)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    expectedACKS = 2 ^ (numI2CBytesToWrite + 1) - 1
    If writeACKS <> expectedACKS Then
        errorString.Text = "unexpected acks!"
    End If
    
    'if(writeACKS != expectedACKS) printf("Expected ACKs = %.0f, Received ACKs = %0.f\n",expectedACKS,writeACKS);


    'When the GoOne processed the read request, the read data was put into the readArray buffer that
    'we passed, so this GetResult is also just to check for an error.
    lngErrorcode = GetResult(lngHandle, LJ_ioI2C_COMMUNICATION, LJ_chI2C_READ, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"


    
    Exit Sub

        


ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
        
        
End Sub


Private Sub Label5_Click()

End Sub

