VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2955
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5850
   LinkTopic       =   "Form1"
   ScaleHeight     =   2955
   ScaleWidth      =   5850
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "0"
      Top             =   1080
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0"
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   5
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'VB6 example to communicate with an LJTick-DAC.  For more advanced LJTDAC
'operations, see the VC6 example.
'support@labjack.com
'Aug 4, 2008

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngErrorcode As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim strError As String * 256
    Dim lngError As Long
    
    Dim pinNum As Double
    pinNum = 2 ' TickDAC will appear on FIO2/FIO3
    
    On Error GoTo ErrorMessage
    
      
    'Open the LabJack.
    'lngErrorcode = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle) 'First found USB U3.
    'lngErrorcode = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle) 'First found USB UE9.
    'lngErrorcode = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle) 'Ethernet UE9.
    lngErrorcode = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle) 'Firstfound USB U6.
    
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngErrorcode)
    'Convert the error code to a string.
    ErrorToString lngErrorcode, strError
    txtOpenErrorString = strError
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    '(U3 only)
    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    'lngErrorcode = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    'If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Specify where the LJTick-DAC is plugged in.
    'This is just setting a parameter in the driver, and not actually talking
    'to the hardware, and thus executes very fast.
    lngErrorcode = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chTDAC_SCL_PIN_NUM, pinNum, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set DACA to 1.2 volts.  If the driver has not previously talked to an LJTDAC
    'on the specified pins, it will first retrieve and store the cal constants.  The
    'low-level I2C command can only update 1 DAC channel at a time, so there
    'is no advantage to doing two updates within a single add-go-get block.
    lngErrorcode = ePut(lngHandle, LJ_ioTDAC_COMMUNICATION, LJ_chTDAC_UPDATE_DACA, 1.2, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set DACB to 2.3 volts.
    lngErrorcode = ePut(lngHandle, LJ_ioTDAC_COMMUNICATION, LJ_chTDAC_UPDATE_DACB, 2.3, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    
    Exit Sub

        


ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
        
        
End Sub


Private Sub Label5_Click()

End Sub
