VERSION 5.00
Begin VB.Form digitalLabel 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox ainListBox 
      Height          =   2790
      ItemData        =   "Form1.frx":0000
      Left            =   360
      List            =   "Form1.frx":0002
      TabIndex        =   5
      Top             =   1920
      Width           =   4095
   End
   Begin VB.TextBox digitalDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   3
      Top             =   600
      Width           =   2295
   End
   Begin VB.TextBox millisecondsDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   4440
      Y1              =   1080
      Y2              =   1080
   End
   Begin VB.Label ainLabel 
      Caption         =   "AIN readings from last iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Digital Input:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1935
   End
   Begin VB.Label millisecondsLabel 
      Caption         =   "Milliseconds Per Iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "digitalLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates using the add/go/get method to efficiently write and read
'  some or all analog and digital I/O on the LabJack U3.
'  Records the time for 1000 iterations and divides by 1000, to allow
'  verification of the basic command/response communication times of the
'  LabJack U3 as documented in Section 3.1 of the U3 User's Guide.
'
'  support@labjack.com
'  Jul 1, 2009
'----------------------------------------------------------------------
'

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    lngHandle = 0
    Dim lngGetNextIteration As Long
    Dim ch As Integer
    Dim strError As String * 256
    
    Dim lngIOType As Long
    lngIOType = 0
    Dim dblValue As Double
    dblValue = 0
    Dim ValueDIPort As Double
    ValueDIPort = 0
    Dim ValueAIN(16) As Double
    
    Dim time As Long
    time = 0
    Dim numIterations As Long
    Dim lngChannel As Long
    numIterations = 100
    Dim numChannels As Long
    numChannels = 16
    Dim quickSample As Long
    quickSample = 0
    Dim LongSettling As Long
    LongSettling = 1
    Dim i As Integer
    Dim j As Integer
    
    On Error GoTo ErrorMessage

    'Open the first found LabJack.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    

    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Configure quickSample.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, quickSample, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Configure longSettling.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_SETTLING_TIME, LongSettling, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Configure the necessary lines as analog.
    lngError = ePut(lngHandle, LJ_ioPUT_ANALOG_ENABLE_PORT, 0, (2 ^ numChannels) - 1, numChannels)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Now an Add/Go/Get block to configure the timers and counters.  These
    'are configured on EIO0-EIO3, so if more than 8 analog inputs are
    'enabled then the analog inputs use these lines.
    If numChannels <= 8 Then
        'Set the timer/counter pin offset to 8, which will put the first
        'timer/counter on EIO0.
        lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_COUNTER_PIN_OFFSET, 8, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Use the default clock source.
        lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc48MHZ, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Enable 2 timers.
        lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 2, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Configure Timer0 as 8-bit PWM.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Set the PWM duty cycle to 50%.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Configure Timer1 as 8-bit PWM.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmPWM8, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Set the PWM duty cycle to 50%.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 32768, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Enable Counter0.
        lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 1, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 1, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Execute the requests.
        lngError = GoOne(lngHandle)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    End If

    'Now add requests that will be processed every iteration of the loop.

    'Add analog input requests.
    For j = 0 To numChannels - 1
        lngError = AddRequest(lngHandle, LJ_ioGET_AIN, j, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    Next j

    'Set DAC0 to 2.5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DAC, 0, 2.5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Read CIO digital lines.
    lngError = AddRequest(lngHandle, LJ_ioGET_DIGITAL_PORT, 16, 0, 4, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Only do the timer/counter stuff if there are less than 8 analog inputs.
    If numChannels <= 8 Then
        lngError = AddRequest(lngHandle, LJ_ioGET_COUNTER, 0, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        lngError = AddRequest(lngHandle, LJ_ioGET_COUNTER, 1, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 0, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 1, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Set the PWM duty cycle to 50%.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Set the PWM duty cycle to 50%.
        lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 32768, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    End If

    time = GetTickCount()

    For i = 0 To numIterations - 1

        'Execute the requests.
        lngError = GoOne(lngHandle)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Get all the results.  The input measurement results are stored.  All other
        'results are for configuration or output requests so we are just checking
        'whether there was an error.
        lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        lngGetNextIteration = 0 'Used by the error handling function.
        While lngError < LJE_MIN_GROUP_ERROR
            Select Case lngIOType

                Case LJ_ioGET_AIN:
                    ValueAIN(lngChannel) = dblValue

                Case LJ_ioGET_DIGITAL_PORT:
                    ValueDIPort = dblValue
                    
            End Select

            lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
            If Not lngError = LJE_NO_MORE_DATA_AVAILABLE And Not lngError = 0 Then
                Err.Raise lngError
            End If
                    
            lngGetNextIteration = lngGetNextIteration + 1
        
        Wend
            
    Next i

    time = GetTickCount() - time

    millisecondsDisplay.Text = (time / numIterations)
    
    digitalDisplay.Text = ValueDIPort
    
    ainListBox.Clear
    
    For j = 0 To numChannels - 1
        ainListBox.AddItem (ValueAIN(j))
    Next j
    
    Exit Sub

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
