VERSION 5.00
Begin VB.Form digitalLabel 
   Caption         =   "Form1"
   ClientHeight    =   1290
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1290
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox readDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   3
      Top             =   600
      Width           =   2295
   End
   Begin VB.TextBox preReadDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
   Begin VB.Label readLabel 
      Caption         =   "Read data:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1935
   End
   Begin VB.Label preLabel 
      Caption         =   "Pre-Read Buffer Size:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "digitalLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  U3_Asynch.vb
'
'   Demonstrates asynchronous communication using a loopback from
'   FIO4 to FIO5 on a U3 rev 1.30.  On earlier hardware revisions
'  use SDA and SCL.
'
'  support@labjack.com
'  July 1, 2009
'----------------------------------------------------------------------
'

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    'long lngGetNextIteration
    'long lngIOType=0, lngChannel=0
    'double dblValue=0
    Dim lngHandle As Long
    lngHandle = 0

    'double numI2CBytesToWrite
    Dim numBytes As Double
    Dim datArray(2) As Byte

    'Open the LabJack.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    ' 1 MHz timer clock base.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc1MHZ_DIV, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Set clock divisor to 1, so timer clock is 1 MHz.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, LJ_tc1MHZ_DIV, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Set timer/counter pin offset to 4. TX and RX appear after any timers and counters on U3
    ' hardware rev 1.30.  We have no timers or counters enabled, so TX=FIO4 and RX=FIO5.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_COUNTER_PIN_OFFSET, 4, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Set data rate for 9600 bps communication.
    lngError = ePut(lngHandle, LJ_ioPUT_CONFIG, LJ_chASYNCH_BAUDFACTOR, 204, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Enable UART.
    lngError = ePut(lngHandle, LJ_ioASYNCH_COMMUNICATION, LJ_chASYNCH_ENABLE, 1, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Transmit 2 bytes.
    numBytes = 10
    datArray(0) = 12
    datArray(1) = 34
    lngError = eGet_ByRef(lngHandle, LJ_ioASYNCH_COMMUNICATION, LJ_chASYNCH_TX, numBytes, datArray(0))
    If lngError <> 0 Then Err.Raise lngError + 50000

    ' Read 2 bytes.
    numBytes = 9999  'Dummy values so we can see them change.
    datArray(0) = 222
    datArray(1) = 222
    lngError = eGet_ByRef(lngHandle, LJ_ioASYNCH_COMMUNICATION, LJ_chASYNCH_RX, numBytes, datArray(0))
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Display the read data.
    preReadDisplay.Text = numBytes
    readDisplay.Text = Str(datArray(0)) + ", " + Str(datArray(1))
ErrorMessage:
    Dim strError As String
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
