VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3960
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6045
   LinkTopic       =   "Form1"
   ScaleHeight     =   3960
   ScaleWidth      =   6045
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtQuad 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0"
      Top             =   3000
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   6
      Text            =   "0"
      Top             =   2160
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "0"
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Quadrature Count"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   7
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Simple VB example interfaces with the UD driver and
'demonstrates quadrature on the U3.  Enables the quadrature input,
'waits two seconds, and then reads the count.  To make something happen
'without an actual quadrature signal, connect a couple wires to
'ground and tap them on FIO4 and FIO5.

'support@labjack.com
'11/13/2007

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    Dim dblDriverVersion As Double
    Dim strError As String * 256
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim dblTimer0 As Double
    
    On Error GoTo ErrorMessage
        
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
    
    'Open the first found LabJack U3 over USB.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'Enable 2 timers for a single quadrature channel.  FIO4 will be
    'the A channel and FIO5 will be the B channel.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Offset the timer/counters by 4 so they start appearing on FIO4.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_COUNTER_PIN_OFFSET, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer0 as Quad A.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, 8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer1 as Quad B.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, 8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Execute the list of requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    While lngError = 0
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    Wend
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
      
    'Wait a second, then read Timer0.
    Sleep 2000
    lngError = eGet(lngHandle, LJ_ioGET_TIMER, 0, dblTimer0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtQuad = Str(dblTimer0)
    
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    Exit Sub
        
End Sub


