VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1770
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1770
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox readListBox 
      Height          =   1425
      ItemData        =   "Form1.frx":0000
      Left            =   2160
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label readLabel 
      Caption         =   "Read data:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates SPI communication.
'
'  You can short MOSI to MISO for testing.
'
'  MOSI    FIO2
'  MISO    FIO3
'  CLK     FIO0
'  CS      FIO1
'
'  If you short MISO to MOSI, then you will read back the same bytes that you write.  If you short
'  MISO to GND, then you will read back zeros.  If you short MISO to VS or leave it
'  unconnected, you will read back 255s.
'
'  Tested with UD driver V2.73 and U3 firmware V1.40.
'
'  support@labjack.com
'  Apr 26, 2007
'----------------------------------------------------------------------
'

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim lngChannel As Long
    lngChannel = 0
    Dim dblValue As Double
    dblValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim numSPIBytesToTransfer As Double
    Dim dataArray(50) As Byte

    'Open the LabJack U3.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    If lngError <> 0 Then Err.Raise lngError
    
    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'First, configure the SPI communication.

    'Enable automatic chip-select control.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_AUTO_CS, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Do not disable automatic digital i/o direction configuration.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_DISABLE_DIR_CONFIG, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Mode A:  CPHA=1, CPOL=1.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MODE, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    '125kHz clock.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CLOCK_FACTOR, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'MOSI is FIO2
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MOSI_PINNUM, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError
    
    'MISO is FIO3
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MISO_PINNUM, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'CLK is FIO0
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CLK_PINNUM, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'CS is FIO1
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CS_PINNUM, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError
    While (lngError < LJE_MIN_GROUP_ERROR)
    
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If Not (lngError = LJE_NO_MORE_DATA_AVAILABLE) And lngError <> 0 Then Err.Raise lngError

    Wend


    'This example transfers 4 test bytes.
    numSPIBytesToTransfer = 4
    dataArray(0) = 170
    dataArray(1) = 240
    dataArray(2) = 170
    dataArray(3) = 240
    
    'Transfer the data.  The write and read is done at the same time.
    lngError = eGet_ByRef(lngHandle, LJ_ioSPI_COMMUNICATION, 0, numSPIBytesToTransfer, dataArray(0))
    If lngError <> 0 Then Err.Raise lngError

    'Display the read data.
    readListBox.Clear
    readListBox.AddItem (dataArray(0))
    readListBox.AddItem (dataArray(1))
    readListBox.AddItem (dataArray(2))
    readListBox.AddItem (dataArray(3))

ErrorMessage:
    Dim strError As String
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
