VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1770
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1770
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox readListBox 
      Height          =   1425
      ItemData        =   "Form1.frx":0000
      Left            =   2160
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label readLabel 
      Caption         =   "Read data:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Basic U3 example does a PWM output and a counter input, using AddGoGet method.
'
'  support@labjack.com
'  Jul 21, 2009
'----------------------------------------------------------------------
'

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    Dim lngError As Long
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim lngChannel As Long
    lngChannel = 0
    Dim dblValue As Double
    dblValue = 0
    Dim lngHandle As Long
    lngHandle = 0


    'Open the first found LabJack U3.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    If lngError <> 0 Then Err.Raise lngError

    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError


    'First requests to configure the timer and counter.  These will be
    'done with and add/go/get block.

    'Set the timer/counter pin offset to 4, which will put the first
    'timer/counter on FIO4.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_COUNTER_PIN_OFFSET, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Use the 48 MHz timer clock base with divider.  Since we are using clock with divisor
    'support, Counter0 is not available.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc48MHZ_DIV, 0, 0)
    'lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc24MHZ_DIV, 0, 0)  'Use this line instead for hardware rev 1.20.
    If lngError <> 0 Then Err.Raise lngError

    'Set the divisor to 48 so the actual timer clock is 1 MHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 48, 0, 0)
    'lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 24, 0, 0)  'Use this line instead for hardware rev 1.20.
    If lngError <> 0 Then Err.Raise lngError

    'Enable 1 timer.  It will use FIO4.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Configure Timer0 as 8-bit PWM.  Frequency will be 1M/256 = 3906 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Set the PWM duty cycle to 50%.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Enable Counter1.  It will use FIO5 since 1 timer is enabled.
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'Execute the requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError

    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If (Not lngError = LJE_NO_MORE_DATA_AVAILABLE) And lngError <> 0 Then Err.Raise lngError
    Wend


    'Wait 1 second.
    Sleep (1000)

    'Request a read from the counter.
    lngError = eGet(lngHandle, LJ_ioGET_COUNTER, 1, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError

    'This should read roughly 4k counts if FIO4 is shorted to FIO5.
    readListBox.AddItem (dblValue)

    'Wait 1 second.
    Sleep (1000)

    'Request a read from the counter.
    lngError = eGet(lngHandle, LJ_ioGET_COUNTER, 1, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError

    'This should read about 3906 counts more than the previous read.
    readListBox.AddItem (dblValue)

    'Reset all pin assignments to factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError

    'The PWM output sets FIO4 to output, so we do a read here to set
    'it to input.
    lngError = eGet(lngHandle, LJ_ioGET_DIGITAL_BIT, 4, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError
    
ErrorMessage:
    Dim strError As String
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
