VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox ainListBox 
      Height          =   2790
      ItemData        =   "Form1.frx":0000
      Left            =   360
      List            =   "Form1.frx":0002
      TabIndex        =   5
      Top             =   1920
      Width           =   4095
   End
   Begin VB.TextBox digitalDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   3
      Top             =   600
      Width           =   2295
   End
   Begin VB.TextBox millisecondsDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   4440
      Y1              =   1080
      Y2              =   1080
   End
   Begin VB.Label ainLabel 
      Caption         =   "AIN readings from last iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Digital Input:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1935
   End
   Begin VB.Label millisecondsLabel 
      Caption         =   "Milliseconds Per Iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates using the add/go/get method to efficiently write and read
'  some or all analog and digital I/O on the LabJack U3.
'  Records the time for 1000 iterations and divides by 1000, to allow
'  verification of the basic command/response communication times of the
'  LabJack U6 as documented in Section 3.1 of the U3 User's Guide.
'
'  support@labjack.com
'  Jul 1, 2009
'----------------------------------------------------------------------
'

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngHandle As Long
    lngHandle = 0
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim lngChannel As Long
    lngChannel = 0
    Dim dblValue As Double
    dblValue = 0
    Dim ValueDIPort As Double
    ValueDIPort = 0
    Dim ValueAIN(16) As Double
    Dim time As Long
    time = 0
    Dim numIterations As Long
    numIterations = 1000
    Dim numChannels As Long
    numChannels = 5
    Dim ainResolution As Long
    ainResolution = 12
    Dim strError As String
    Dim i, j As Integer

    'Open the first found LabJack U6.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack (LJ_dtU6, LJ_ctETHERNET, "192.168.1.38", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Set DAC0 to 2.5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DAC, 0, 2.5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 allows VB6 to identify the error as "user-defined"

    'Set DAC1 to 3.5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DAC, 1, 3.5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Write all digital I/O.  Doing a bunch of bit instructions, rather than
    'the following port instruction, should not make a noticable difference
    'in the overall execution time.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DIGITAL_PORT, 0, 0, 23, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure the desired resolution.  Note that depending on resolution and
    'number of analog inputs, numIterations might need to be reduced from the
    'default above so the program does not take too long to execute.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, ainResolution, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Add analog input requests.
    For j = 0 To numChannels - 1
        lngError = AddRequest(lngHandle, LJ_ioGET_AIN, j, 0, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000
    Next j

    'Request a read of all digital I/O.  Doing a bunch of bit instructions,
    'rather than the following port instruction, should not make a noticable
    'difference in the overall execution time.
    lngError = AddRequest(lngHandle, LJ_ioGET_DIGITAL_PORT, 0, 0, 23, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    time = GetTickCount()

    For i = 0 To numIterations - 1

        'Execute the requests.
        lngError = GoOne(lngHandle)
        If lngError <> 0 Then Err.Raise lngError + 50000

        'Get all the results.  The input measurement results are stored.  All other
        'results are for configuration or output requests so we are just checking
        'whether there was an error.
        lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> 0 Then Err.Raise lngError + 50000
        lngGetNextIteration = 0 'Used by the error handling function.
        While (lngError < LJE_MIN_GROUP_ERROR)
            Select Case lngIOType

                Case LJ_ioGET_AIN: ValueAIN(lngChannel) = dblValue
    
                Case LJ_ioGET_DIGITAL_PORT: ValueDIPort = dblValue
            
            End Select

            lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
            If (Not lngError = LJE_NO_MORE_DATA_AVAILABLE) And lngError <> 0 Then Err.Raise lngError + 50000

        Wend
    
    Next i

    time = GetTickCount() - time

    millisecondsDisplay.Text = (time / numIterations)

    digitalDisplay.Text = ValueDIPort

    For j = 0 To numChannels - 1
        ainListBox.AddItem (ValueAIN(j))
    Next j

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
