VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2340
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5025
   LinkTopic       =   "Form1"
   ScaleHeight     =   2340
   ScaleWidth      =   5025
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox dataArrayDisplay 
      Height          =   2010
      ItemData        =   "Form1.frx":0000
      Left            =   1680
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   3015
   End
   Begin VB.Label dataArrayLabel 
      Caption         =   "Data Array:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates SPI communication.
'
'  You can short MOSI to MISO for testing.
'
'  MOSI    FIO2
'  MISO    FIO3
'  CLK      FIO0
'  CS        FIO1
'
'  If you short MISO to MOSI, then you will read back the same bytes that you write.  If you short
'  MISO to GND, then you will read back zeros.  If you short MISO to VS or leave it
'  unconnected, you will read back 255s.
'
'  support@labjack.com
'  July 10, 2009
'----------------------------------------------------------------------
'

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()

    Dim lngError As Long
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim dblValue As Double
    dblValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim numSPIBytesToTransfer As Double
    Dim dataArray(50) As Byte
    Dim lngChannel As Long
    Dim strError As String

    'Open the LabJack U6.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle)
    'errorcode = OpenLabJack (LJ_dtU6, LJ_ctETHERNET, "192.168.1.209", 0, Handle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'First, configure the SPI communication.

    'Enable automatic chip-select control.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_AUTO_CS, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Do not disable automatic digital i/o direction configuration.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_DISABLE_DIR_CONFIG, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Mode A:  CPHA=1, CPOL=1.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MODE, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    '125kHz clock.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CLOCK_FACTOR, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'MOSI is FIO2
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MOSI_PINNUM, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    
    'MISO is FIO3
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_MISO_PINNUM, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'CLK is FIO0
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CLK_PINNUM, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'CS is FIO1
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSPI_CS_PINNUM, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> 0 And lngError <> LJE_NO_MORE_DATA_AVAILABLE Then Err.Raise lngError + 50000
    Wend

    'This example transfers 4 test bytes.
    numSPIBytesToTransfer = 4
    dataArray(0) = 170
    dataArray(1) = 240
    dataArray(2) = 170
    dataArray(3) = 240
    
    'Transfer the data.  The write and read is done at the same time.
    lngError = eGet_ByRef(lngHandle, LJ_ioSPI_COMMUNICATION, 0, numSPIBytesToTransfer, dataArray(0))
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Display the read data.
    dataArrayDisplay.AddItem (dataArray(0))
    dataArrayDisplay.AddItem (dataArray(1))
    dataArrayDisplay.AddItem (dataArray(2))
    dataArrayDisplay.AddItem (dataArray(3))
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
