VERSION 5.00
Begin VB.Form Thermocouple_form 
   Caption         =   "U6 Thermocouple"
   ClientHeight    =   2565
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   2565
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton buttonGetTemp 
      Caption         =   "Get Reading"
      Height          =   375
      Left            =   4080
      TabIndex        =   12
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtThermo 
      Height          =   285
      Left            =   3480
      TabIndex        =   10
      Text            =   "0.0"
      Top             =   2040
      Width           =   1095
   End
   Begin VB.TextBox txtInternal 
      Height          =   285
      Left            =   1920
      TabIndex        =   9
      Text            =   "0.0"
      Top             =   2040
      Width           =   855
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   0
      TabIndex        =   3
      Text            =   "0.0"
      Top             =   240
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   0
      TabIndex        =   2
      Text            =   "0"
      Top             =   960
      Width           =   1335
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1680
      TabIndex        =   1
      Text            =   "0"
      Top             =   960
      Width           =   3495
   End
   Begin VB.TextBox txtAIN0 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   2040
      Width           =   1575
   End
   Begin VB.Label Label4 
      Caption         =   "Thermocouple (F)"
      Height          =   495
      Left            =   3480
      TabIndex        =   11
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Internal (F)"
      Height          =   495
      Left            =   1920
      TabIndex        =   8
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   0
      TabIndex        =   7
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   0
      TabIndex        =   6
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1680
      TabIndex        =   5
      Top             =   720
      Width           =   3495
   End
   Begin VB.Label Label5 
      Caption         =   "AIN Voltage"
      Height          =   495
      Left            =   0
      TabIndex        =   4
      Top             =   1800
      Width           =   1455
   End
End
Attribute VB_Name = "Thermocouple_form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Demonstrates using the TCVoltsToTemp function to yield temperature
'  readings for a thermocouple directly connected to a U6.
'
'  Setup:
'  TC plus to AIN0.
'  TC minus to GND.
'
'  If you do not want all the thermocouple minus leads tied together
'  at GND, you can use differential channels instead.  Connect the minus
'  to AIN1 in that case, and use a 10k resistor from AIN1 to GND to
'  provide a path for bias currents.
'
'support@labjack.com
'November 17, 2009
'
'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.
'
'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Dim lngError As Long
Dim lngHandle As Long
Dim lngIOType As Long
Dim lngChannel As Long
Dim dblDriverVersion As Double
Dim strError As String * 256
Dim dblAIN As Double
Dim dblInternal As Double
Dim ainResolution As Double
Dim TCVolts As Double
Dim cjTemp As Double

Dim pTCTempK As Double
Dim offSetVoltage As Double

Dim TCType As Long
'Thermal couple type
'Possible types and their associated constants are:
'LJ_ttB = 6001
'LJ_ttE = 6002
'LJ_ttJ = 6003
'LJ_ttK = 6004
'LJ_ttN = 6005
'LJ_ttR = 6006
'LJ_ttS = 6007
'LJ_ttT = 6008

Public Sub errorFunction(ByVal errNumber As Long, ByVal stringError As String)
    ErrorToString errNumber - 50000, stringError
    txtOpenErrorString = stringError
    txtOpenErrorNumber = errNumber
End Sub


'Function to acquire a new reading
Private Sub buttonGetTemp_Click()

    On Error GoTo errMessage
    
    'Get a reading from AIN0.
    lngError = eGet(lngHandle, LJ_ioGET_AIN, lngChannel, dblAIN, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    'Get a reading from Internal Temperature Sensor (cjTemp in this example)
    lngError = eGet(lngHandle, LJ_ioGET_AIN, 14, dblInternal, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    'The cold junction is the screw-terminal block where the thermocouple
    'is connected.  As discussed in the U6 User's Guide, add 2.5 degrees C
    'to the internal temp sensor reading.  If using the CB37 rather than
    'the built-in screw terminals, just add 1.0 degrees C.
    cjTemp = dblInternal + 2.5
        
    lngError = TCVoltsToTemp(TCType, dblAIN, cjTemp, pTCTempK)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Display the results
    txtAIN0 = Format(dblAIN, "#.00000000")
    txtInternal = Format(dblInternal * 9 / 5# - 459.67, "###.#") 'Display results in deg. F
    txtThermo = Format(pTCTempK * 9 / 5# - 459.67, "###.#") 'Display results in deg. F
    Thermocouple_form.Show
    
errMessage:
    errorFunction Err.Number, strError

End Sub


Private Sub Form_Load()
    
    On Error GoTo ErrorMessage
        
    ainResolution = 12  'A resolution index of 12 means "max" for a U6 or U6-Pro.
    
    'Channel which the TC is on (AIN0 equates to lngChannel = 0)
    lngChannel = 0
    
    TCType = LJ_ttT
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
    'Open the first found LabJack U6 over USB.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
       
    'Set the resolution to ainResolution
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, ainResolution, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set the range on the analog input channel to +/-0.1 volts (x100 gain).
    lngError = eGet(lngHandle, LJ_ioPUT_AIN_RANGE, lngChannel, LJ_rgBIPP1V, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
'Simple error message function
ErrorMessage:
    errorFunction Err.Number, strError
End Sub

