VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1770
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1770
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox readListBox 
      Height          =   1425
      ItemData        =   "Form1.frx":0000
      Left            =   2160
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label readLabel 
      Caption         =   "Read data:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates a few of different timer/counter features.
'
'  support@labjack.com
'  July 6, 2009
'----------------------------------------------------------------------
'


Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    Dim lngError As Long
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim dblValue As Double
    dblValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim resetCounter As Long
    resetCounter = 1
    Dim count As Double
    count = -1
    Dim highTime, lowTime As Double
    Dim period16, period32 As Double
    Dim lngChannel As Long

    'Open the LabJack U6.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle)
    'errorcode = OpenLabJack (LJ_dtU6, LJ_ctETHERNET, "192.168.1.209", 0, Handle)
    If lngError <> 0 Then Err.Raise lngError + 50000 ' Adding 50000 helps VB6 identify errors as "user-defined"


    'Disable all timers and counters to put everything in a known initial state.
    'Disable the timer and counter, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 0, 0, 0)
    lngError = GoOne(lngHandle)


    'First we will output a square wave and count the number of pulses for about 1 second.
    'Connect a jumper on the U6 from FIO0 (PWM output) to
    'FIO1 (Counter0 input).

    'Use the fixed 750kHz timer clock source.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc4MHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the divisor to 4 so the actual timer clock is 1MHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable 1 timer.  It will use FIO0.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 50%.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable Counter0.  It will use FIO1 since 1 timer is enabled.
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE And lngError <> 0 Then Err.Raise lngError + 50000
    Wend


    'Wait 1 second.
    Sleep (1000)

    'Request a read from the counter.
    lngError = eGet(lngHandle, LJ_ioGET_COUNTER, 0, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'This should read roughly 977 counts.
    readListBox.AddItem ("Counter = " + Str(dblValue))

    'Disable the timer and counter, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    lngError = GoOne(lngHandle)




    'Output a square wave and measure the period.
    'Connect a jumper on the U6 from FIO0 (PWM8 output) to
    'FIO1 (RISINGEDGES32 input) and FIO2 (RISINGEDGES16).

    'Use the fixed 750kHz timer clock source.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc4MHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the divisor to 4 so the actual timer clock is 1MHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable 3 timers.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 50%.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer1 as 32-bit period measurement.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmRISINGEDGES32, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer2 as 16-bit period measurement.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 2, LJ_tmRISINGEDGES16, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While lngError < LJE_MIN_GROUP_ERROR
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE And lngError <> 0 Then Err.Raise lngError + 50000
    Wend

    'Wait 1 second.
    Sleep (1000)

    'Now read the period measurements from the 2 timers.  We
    'will use the Add/Go/Get method so that both
    'reads are done in a single low-level call.

    'Request a read from Timer1
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 1, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Request a read from Timer2
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 2, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Get the results of the two read requests.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        Select Case lngIOType
        Case LJ_ioGET_TIMER:
            Select Case lngChannel
                Case 1: period32 = dblValue
                Case 2: period16 = dblValue
            End Select
        End Select

        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE And lngError <> 0 Then Err.Raise lngError + 50000
    Wend


    'Both period measurements should read about 256.  The timer
    'clock was set to 250 kHz, so each tick equals 4 microseconds, so
    '256 ticks means a period of 1024 microseconds which is a frequency
    'of 977 Hz.
    readListBox.AddItem ("Period32 = " + Str(period32))
    readListBox.AddItem ("Period16 = " + Str(period16))

    'Disable the timer and counter, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    lngError = GoOne(lngHandle)

    'Now we will output a 25% duty-cycle PWM output on Timer0 (FIO0) and measure
    'the duty cycle on Timer1 FIO1.  Requires Control firmware V1.21 or higher.

    'Use the fixed 4MHz timer clock source.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc4MHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the divisor to 4 so the actual timer clock is 1MHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable 2 timers.  They will use FIO0 and FIO1.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 25%.  The passed value is the low time.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 49152, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer1 as duty cycle measurement.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmDUTYCYCLE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE And lngError <> 0 Then Err.Raise lngError + 50000
    Wend


    'Wait a little so we are sure a duty cycle measurement has occured.
    Sleep (100)

    'Request a read from Timer1.
    lngError = eGet(lngHandle, LJ_ioGET_TIMER, 1, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'High time is LSW
    highTime = dblValue Mod 65536
    'Low time is MSW
    lowTime = dblValue / 65536

    readListBox.AddItem ("High clicks = " + Str(highTime))
    readListBox.AddItem ("Low clicks = " + Str(lowTime))
    readListBox.AddItem ("Duty cycle = " + Str(100 * highTime / (highTime + lowTime)))


    'Disable the timers, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = GoOne(lngHandle)


    'The PWM output sets FIO0 to output, so we do a read here to set
    'FIO0 to input.
    lngError = eGet(lngHandle, LJ_ioGET_DIGITAL_BIT, 0, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    
ErrorMessage:
    Dim strError As String
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
