VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4485
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   4485
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox resultsListBox 
      Height          =   4740
      ItemData        =   "Form1.frx":0000
      Left            =   720
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   480
      Width           =   3615
   End
   Begin VB.Label resultsLabel 
      Caption         =   "Results:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  efunctions example
'
'  Demonstrates the UD E-functions with the LabJack UE9.
'
'  support@labjack.com
'  Jun 12, 2006
'----------------------------------------------------------------------
'

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    'long lngIOType=0, lngChannel=0
    Dim dblValue As Double
    dblValue = 0
    Dim lngValue As Long
    lngValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim TCPinOffset As Long
    TCPinOffset = 0
    Dim strError As String
    'long lngGetNextIteration
    'char ch

    Dim lngRange, lngResolution, lngBinary As Long
    Dim alngEnableTimers(5) As Long
    Dim alngEnableCounters(1), lngTimerClockBaseIndex, lngTimerClockDivisor, alngTimerModes(6) As Long
    Dim adblTimerValues(5) As Double
    Dim alngReadTimers(6), alngUpdateResetTimers(6), alngReadCounters(2), alngResetCounters(2) As Long
    Dim adblCounterValues(2) As Double
    Dim highTime, lowTime, dutyCycle As Double


    'Open the first found LabJack UE9.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack (LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Take a measurement from AIN3.
    lngRange = LJ_rgBIP5V
    lngResolution = 17
    lngBinary = 0
    lngError = eAIN(lngHandle, 3, 0, dblValue, lngRange, lngResolution, -1, lngBinary, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("AIN3 = " + Str(dblValue))

    'Set DAC0 to 3.0 volts.
    dblValue = 3#
    lngBinary = 0
    lngError = eDAC(lngHandle, 0, dblValue, lngBinary, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("DAC0 set to " + Str(dblValue) + " volts")

    'Read state of FIO2.
    lngError = eDI(lngHandle, 2, lngValue)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("FIO2 = " + Str(lngValue))

    'Set the state of FIO3.
    lngValue = 0
    lngError = eDO(lngHandle, 3, lngValue)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("FIO3 set to = " + Str(lngValue))


    'Timers and Counters example.
    'First, a call to eTCConfig.  Fill the datArrays with the desired values, then make the call.
    lngTimerClockBaseIndex = LJ_tc750KHZ  'Choose 750 kHz base clock.
    lngTimerClockDivisor = 3 'Divide by 3, thus timer clock is 250 kHz.
    alngEnableTimers(0) = 1 'Enable Timer0 (uses FIO0).
    alngEnableTimers(1) = 1 'Enable Timer1 (uses FIO1).
    alngEnableTimers(2) = 1 'Enable Timer2 (uses FIO2).
    alngEnableTimers(3) = 1 'Enable Timer3 (uses FIO3).
    alngEnableTimers(4) = 0 'Disable Timer4.
    alngEnableTimers(5) = 0 'Disable Timer5.
    alngTimerModes(0) = LJ_tmPWM8 'Timer0 is 8-bit PWM output.  Frequency is 250k/256 = 977 Hz.
    alngTimerModes(1) = LJ_tmDUTYCYCLE 'Timer1 is duty cyle input.
    alngTimerModes(2) = LJ_tmFIRMCOUNTER 'Timer2 is firmware counter input.
    alngTimerModes(3) = LJ_tmRISINGEDGES16 'Timer3 is 16-bit period measurement.
    alngTimerModes(4) = 0 'Timer4 not enabled.
    alngTimerModes(5) = 0 'Timer5 not enabled.
    adblTimerValues(0) = 16384 'Set PWM8 duty-cycle to 75%.
    adblTimerValues(1) = 0
    adblTimerValues(2) = 0
    adblTimerValues(3) = 0
    adblTimerValues(4) = 0
    adblTimerValues(5) = 0
    alngEnableCounters(0) = 1 'Enable Counter0 (uses FIO4).
    alngEnableCounters(1) = 1 'Enable Counter1 (uses FIO5).
    lngError = eTCConfig(lngHandle, alngEnableTimers(0), alngEnableCounters(0), TCPinOffset, lngTimerClockBaseIndex, lngTimerClockDivisor, alngTimerModes(0), adblTimerValues(0), 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    

    Sleep (1000) 'Wait 1 second.

    'Now, a call to eTCValues.
    alngReadTimers(0) = 0 'Don't read Timer0 (output timer).
    alngReadTimers(1) = 1 'Read Timer1
    alngReadTimers(2) = 1 'Read Timer2
    alngReadTimers(3) = 1 'Read Timer3
    alngReadTimers(4) = 0 'Timer4 not enabled.
    alngReadTimers(5) = 0 'Timer5 not enabled.
    alngUpdateResetTimers(0) = 1 'Update Timer0
    alngUpdateResetTimers(1) = 1 'Reset Timer1
    alngUpdateResetTimers(2) = 1 'Reset Timer2
    alngUpdateResetTimers(3) = 1 'Reset Timer3
    alngUpdateResetTimers(4) = 0 'Timer4 not enabled.
    alngUpdateResetTimers(5) = 0 'Timer5 not enabled.
    alngReadCounters(0) = 1 'Read Counter0
    alngReadCounters(1) = 1 'Read Counter1
    alngResetCounters(0) = 1 'Reset Counter0.
    alngResetCounters(1) = 1 'Reset Counter1.
    adblTimerValues(0) = 32768 'Change Timer0 duty-cycle to 50%.
    adblTimerValues(1) = 0
    adblTimerValues(2) = 0
    adblTimerValues(3) = 0
    adblTimerValues(4) = 0
    adblTimerValues(5) = 0
    lngError = eTCValues(lngHandle, alngReadTimers(0), alngUpdateResetTimers(0), alngReadCounters(0), alngResetCounters(0), adblTimerValues(0), adblCounterValues(0), 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("Timer1 value = " + Str(adblTimerValues(1)))
    resultsListBox.AddItem ("Timer2 value = " + Str(adblTimerValues(2)))
    resultsListBox.AddItem ("Timer3 value = " + Str(adblTimerValues(3)))
    resultsListBox.AddItem ("Counter0 value = " + Str(adblCounterValues(0)))
    resultsListBox.AddItem ("Counter1 value = " + Str(adblCounterValues(1)))

    'Convert Timer1 value to duty-cycle percentage.
    'High time is LSW
    highTime = ((adblTimerValues(1)) Mod (65536))
    'Low time is MSW
    lowTime = ((adblTimerValues(1)) / (65536))
    'Calculate the duty cycle percentage.
    dutyCycle = 100 * highTime / (highTime + lowTime)
    resultsListBox.AddItem ("High clicks Timer1 = " + Str(highTime))
    resultsListBox.AddItem ("Low clicks Timer1 = " + Str(lowTime))
    resultsListBox.AddItem ("Duty cycle Timer1 = " + Str(dutyCycle))


    'Disable all timers and counters.
    alngEnableTimers(0) = 0
    alngEnableTimers(1) = 0
    alngEnableTimers(2) = 0
    alngEnableTimers(3) = 0
    alngEnableTimers(4) = 0
    alngEnableTimers(5) = 0
    alngEnableCounters(0) = 0
    alngEnableCounters(1) = 0
    lngError = eTCConfig(lngHandle, alngEnableTimers(0), alngEnableCounters(0), 0, lngTimerClockBaseIndex, lngTimerClockDivisor, alngTimerModes(0), adblTimerValues(0), 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


