VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5475
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   ScaleHeight     =   5475
   ScaleWidth      =   4905
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox commBacklogDisplay 
      Height          =   285
      Left            =   2640
      TabIndex        =   8
      Top             =   4440
      Width           =   2055
   End
   Begin VB.ListBox firstScanDisplay 
      Height          =   3180
      ItemData        =   "Form1.frx":0000
      Left            =   2640
      List            =   "Form1.frx":0002
      TabIndex        =   6
      Top             =   1080
      Width           =   2175
   End
   Begin VB.TextBox numberReadDisplay 
      Height          =   285
      Left            =   2640
      TabIndex        =   4
      Top             =   600
      Width           =   2175
   End
   Begin VB.TextBox iterationDisplay 
      Height          =   285
      Left            =   2640
      TabIndex        =   2
      Top             =   120
      Width           =   2175
   End
   Begin VB.CommandButton goButton 
      Caption         =   "Go!"
      Height          =   495
      Left            =   720
      TabIndex        =   0
      Top             =   4920
      Width           =   3495
   End
   Begin VB.Label backlogLabel 
      Caption         =   "Comm Backlog:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   4440
      Width           =   2295
   End
   Begin VB.Label firstScanLabel 
      Caption         =   "First Scan:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   2415
   End
   Begin VB.Label numberReadLabel 
      Caption         =   "Number Read:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   2415
   End
   Begin VB.Label iterationLabel 
      Caption         =   "Iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Does a 6-channel externally triggered stream of AIN0, AIN1, EIO_FIO,
'  MIO_CIO, Timer0_Low, and Timer0_High.
'
'  Timer0 (FIO0) is enabled as SystemTimerLow (mode 10).  With an externally
'  triggered stream, the timing is determined by the external trigger signal,
'  so this timer value can be used to timestamp each scan.
'
'  Timer1 (FIO1) is enabled as frequency output at 1 kHz, and can be
'  used as the external trigger signal for testing.
'
'  External triggering is enabled for the stream, so the trigger signal should
'  be connected to FIO2.
'
'  For testing, connect FIO1 to FIO2.
'
'  support@labjack.com
'  April 30, 2007
'----------------------------------------------------------------------
'

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Dim lngHandle As Long
Dim i As Integer

Private Sub Form_Load()

    'The actual scan rate is determined by the external clock, but we need
    'an idea of how fast the scan rate will be so that we can make
    'the buffers big enough.  Also, the driver needs to have an idea of the
    'expected scan rate to help it decide how big of packets to transfer.
    Dim scanRate As Double
    scanRate = 1000
    Dim delayms As Long
    delayms = 1000
    Dim numScans As Double
    numScans = 2000
    Dim numScansRequested As Double
    Dim adblData(12000) As Double 'Max buffer size (#channels*numScansRequested)

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngChannel As Long
    lngChannel = 0
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim dblValue As Double
    dblValue = 0
    Dim strError As String

    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack (LJ_dtUE9, LJ_ctETHERNET, "192.168.1.184", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Make sure the UE9 is not streaming.
    'lngError = ePut(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Disable all timers and counters to put everything in a known initial state.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 0, 0, 0)
    lngError = GoOne(lngHandle)


    'First we will configure Timer0 as system timer low and configure Timer1 to
    'output a 1000 Hz square wave.

    'Use the fixed 750kHz timer clock source.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc750KHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the divisor to 3 so the actual timer clock is 250 kHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable 2 timers.  They will use FIO0-FIO1.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer0 as system timer low.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmSYSTIMERLOW, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer1 as frequency output.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmFREQOUT, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the frequency output on Timer1 to 1000 Hz (250000/(2*125) = 1000).
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 125, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If (lngError <> LJE_NO_MORE_DATA_AVAILABLE) And lngError <> 0 Then Err.Raise lngError + 50000
    Wend




    'Configure the stream:
    'Configure resolution for all analog inputs.  Since the test external clock
    'is at 1000 Hz, and we are scanning 6 channels, we will have a
    'sample rate of 6000 samples/second.  That means the maximum resolution
    'we could use is 13-bit.  We will use 12-bit in this example.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, 12, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Configure the analog input range on channel 0 for bipolar +-5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_AIN_RANGE, 0, LJ_rgBIP5V, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Configure the analog input range on channel 1 for bipolar +-5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_AIN_RANGE, 1, LJ_rgBIP5V, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Give the driver a 5 second buffer (scanRate * 6 channels * 5 seconds).
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_BUFFER_SIZE, scanRate * 6 * 5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Configure reads to retrieve whatever data is available without waiting (wait mode LJ_swNONE).
    'See comments below to change this program to use LJ_swSLEEP mode.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_WAIT_MODE, LJ_swNONE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Configure for external triggering.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_EXTERNAL_TRIGGER, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Define the scan list.
    lngError = AddRequest(lngHandle, LJ_ioCLEAR_STREAM_CHANNELS, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 0, 0, 0, 0)   'AIN0
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 1, 0, 0, 0)   'AIN1
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 193, 0, 0, 0) 'EIO_FIO
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 194, 0, 0, 0) 'MIO_CIO
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 200, 0, 0, 0) 'Timer0 LSW
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 224, 0, 0, 0) 'Timer0 MSW
    If lngError <> 0 Then Err.Raise lngError + 50000
    
    'Execute the list of requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000
    
    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngGetNextIteration = 0 'Used by the error handling function.
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE And lngError <> 0 Then Err.Raise lngError + 50000
    Wend
    
    'Start the stream.
    lngError = eGet(lngHandle, LJ_ioSTART_STREAM, 0, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo ErrorMessage
    Dim lngError As Long
    Dim strError As String
    Dim adblData(12000) As Double 'Max buffer size (#channels*numScansRequested)
    
    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Disable the timers.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = GoOne(lngHandle)

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
    
End Sub

Private Sub goButton_Click()

    'The actual scan rate is determined by the external clock, but we need
    'an idea of how fast the scan rate will be so that we can make
    'the buffers big enough.  Also, the driver needs to have an idea of the
    'expected scan rate to help it decide how big of packets to transfer.
    Dim scanRate As Double
    scanRate = 1000
    Dim delayms As Long
    delayms = 1000
    Dim numScans As Double
    numScans = 2000
    Dim numScansRequested As Double
    Dim adblData(12000) As Double 'Max buffer size (#channels*numScansRequested)
    Dim k As Integer
    Dim lngError As Long
    Dim dblCommBacklog As Double
    Dim strError As String
    
    i = i + 1
    
    On Error GoTo ErrorMessage

    'Since we are using wait mode LJ_swNONE, we will wait a little, then
    'read however much data is available.  Thus this delay will control how
    'fast the program loops and how much data is read each loop.  An
    'alternative common method is to use wait mode LJ_swSLEEP where the
    'stream read waits for a certain number of scans.  In such a case
    'you would not have a delay here, since the stream read will actually
    'control how fast the program loops.
    '
    'To change this program to use sleep mode,
    '   -change numScans to the actual number of scans desired per read,
    '   -change wait mode addrequest value to LJ_swSLEEP,
    '   -comment out the following Sleep command.

    Sleep (delayms) 'Remove if using LJ_swSLEEP.

    'init datArray so we can easily tell if it has changed
    For k = 0 To numScans * 2 - 1
        adblData(k) = 9999#
    Next k

    'Read the data.  We will request twice the number we expect, to
    'make sure we get everything that is available.
    'Note that the datArray we pass must be sized to hold enough SAMPLES, and
    'the Value we pass specifies the number of SCANS to read.
    numScansRequested = numScans
    lngError = eGet_ByRef(lngHandle, LJ_ioGET_STREAM_DATA, LJ_chALL_CHANNELS, numScansRequested, adblData(0))
    'This displays the number of scans that were actually read.
    iterationDisplay.Text = i
    numberReadDisplay.Text = numScansRequested
    'This displays just the first scan.
    firstScanDisplay.Clear
    firstScanDisplay.AddItem (adblData(0))
    firstScanDisplay.AddItem (adblData(1))
    firstScanDisplay.AddItem (adblData(2))
    firstScanDisplay.AddItem (adblData(3))
    firstScanDisplay.AddItem (adblData(4))
    firstScanDisplay.AddItem (adblData(5))
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Retrieve the current Comm backlog.  The UD driver retrieves stream data from
    'the UE9 in the background, but if the computer is too slow for some reason
    'the driver might not be able to read the data as fast as the UE9 is
    'acquiring it, and thus there will be data left over in the UE9 buffer.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chSTREAM_BACKLOG_COMM, dblCommBacklog, 0)
    commBacklogDisplay.Text = dblCommBacklog

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
    
End Sub

