VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   480
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5025
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleWidth      =   5025
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox millisecondsDisplay 
      Height          =   285
      Left            =   2280
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label millisecondsLabel 
      Caption         =   "Milliseconds Per Iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Simple demonstration of using RAW_OUT and RAW_IN.  Sends a 0x70,0x70
'  which is a do nothing Comm command that simply responds with an echo.
'  Records the time for 1000 iterations and divides by 1000, to determine
'  the basic communication time of the LabJack.
'
'  For more in depth examples of low-level function calls, see the
'  Linux downloads.
'
'  support@labjack.com
'  July 6, 2009
'----------------------------------------------------------------------
'

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function GetTickCount Lib "kernel32" () As Long

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngHandle As Long
    lngHandle = 0
    Dim ch As Byte
    Dim time As Long
    time = 0
    Dim numIterations As Long
    numIterations = 1000
    Dim strError As String

    Dim numBytesToWrite As Double
    Dim numBytesToRead As Double
    Dim writeArray(2) As Byte
    writeArray(0) = 112 ' 0x70
    writeArray(1) = 112 ' 0x70
    Dim readArray(2) As Byte
    Dim i As Integer

    'Open the first found LabJack UE9.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack (LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000

    time = GetTickCount()

    For i = 0 To numIterations - 1
        numBytesToWrite = 2
        numBytesToRead = 2

        'Raw Out
        lngError = eGet_ByRef(lngHandle, LJ_ioRAW_OUT, 0, numBytesToWrite, writeArray(0))
        If lngError <> 0 Then Err.Raise lngError + 50000

        'Raw In
        lngError = eGet_ByRef(lngHandle, LJ_ioRAW_IN, 0, numBytesToRead, readArray(0))
        If lngError <> 0 Then Err.Raise lngError + 50000

    Next i

    time = GetTickCount() - time

    millisecondsDisplay.Text = 1# * time / numIterations
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
