VERSION 5.00
Begin VB.Form Thermocouple_ljtia 
   Caption         =   "UE9 Thermocouple"
   ClientHeight    =   2565
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   2565
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton buttonGetTemp 
      Caption         =   "Get Reading"
      Height          =   375
      Left            =   4080
      TabIndex        =   12
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtThermo 
      Height          =   285
      Left            =   3480
      TabIndex        =   10
      Text            =   "0.0"
      Top             =   2040
      Width           =   1095
   End
   Begin VB.TextBox txtInternal 
      Height          =   285
      Left            =   1920
      TabIndex        =   9
      Text            =   "0.0"
      Top             =   2040
      Width           =   855
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   0
      TabIndex        =   3
      Text            =   "0.0"
      Top             =   240
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   0
      TabIndex        =   2
      Text            =   "0"
      Top             =   960
      Width           =   1335
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1680
      TabIndex        =   1
      Text            =   "0"
      Top             =   960
      Width           =   3495
   End
   Begin VB.TextBox txtAIN0 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   2040
      Width           =   1575
   End
   Begin VB.Label Label4 
      Caption         =   "Thermocouple (K)"
      Height          =   495
      Left            =   3480
      TabIndex        =   11
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Internal (K)"
      Height          =   495
      Left            =   1920
      TabIndex        =   8
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   0
      TabIndex        =   7
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   0
      TabIndex        =   6
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1680
      TabIndex        =   5
      Top             =   720
      Width           =   3495
   End
   Begin VB.Label Label5 
      Caption         =   "AIN Voltage"
      Height          =   495
      Left            =   0
      TabIndex        =   4
      Top             =   1800
      Width           =   1455
   End
End
Attribute VB_Name = "Thermocouple_ljtia"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Demonstrates using the TCVoltsToTemp to yield temperature readings for
'  a thermocouple connected to a UE9 via a LJTick-InAmp.  Information
'  also provided below for direct thermocouple measurements without an LJTIA.
'
'  Setup:
'  TC plus to INA+.
'  TC minus to INA-.
'  10k resistor from INA- to GND on LJTIA (a short is also acceptable in most cases).
'  LJTIA connected to AIN0/AIN1 block on UE9.
'  LJTIA offset set to 0.4 volts.
'  LJTIA channel A gain set to 51.
'
'  For the best accuracy, we recommend doing a quick offset calibration as
'  described in the comments below, and using an external cold-junction
'  temperature sensor rather than the internal UE9 temp sensor.  The internal
'  temp sensor is often sufficient, but an external sensor, such as
'  the LM34CAZ (national.com) or the EI-1034 (labjack.com), placed near
'  the LJTIA, can provide better CJC, particularly when the UE9 itself
'  is subjected to varying temperatures.
'
'  If doing direct measurements without an LJTIA, change the offset and gain
'  parameters below, and perhaps also the AIN_RANGE command.
'
'support@labjack.com
'November 17, 2009
'
'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.
'
'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Dim lngError As Long
Dim lngHandle As Long
Dim lngIOType As Long
Dim lngChannel As Long
Dim dblDriverVersion As Double
Dim strError As String * 256
Dim dblAIN As Double
Dim dblInternal As Double
Dim ainResolution As Double
Dim externalGain As Double
Dim TCVolts As Double

Dim pTCTempK As Double
Dim offSetVoltage As Double

Dim TCType As Long
'Thermal couple type
'Possible types and their associated constants are:
'LJ_ttB = 6001
'LJ_ttE = 6002
'LJ_ttJ = 6003
'LJ_ttK = 6004
'LJ_ttN = 6005
'LJ_ttR = 6006
'LJ_ttS = 6007
'LJ_ttT = 6008

Public Sub errorFunction(ByVal errNumber As Long, ByVal stringError As String)
    If lngError <> 0 Then errNumber = errNumber - 50000
    ErrorToString errNumber, stringError
    txtOpenErrorString = stringError
    txtOpenErrorNumber = errNumber
End Sub


'Function to acquire a new reading
Private Sub buttonGetTemp_Click()

    On Error GoTo ErrorMessage

    'Get a reading from AIN0.
    lngError = eGet(lngHandle, LJ_ioGET_AIN, lngChannel, dblAIN, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get a reading from Internal Temperature Sensor (cjTemp in this example)
    lngError = eGet(lngHandle, LJ_ioGET_AIN, 133, dblInternal, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    TCVolts = (dblAIN - offSetVoltage) / externalGain
    
    lngError = TCVoltsToTemp(TCType, TCVolts, dblInternal, pTCTempK)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Display the results
    txtAIN0 = Format(dblAIN, "#.######")
    txtInternal = Format(dblInternal, "###.#")
    txtThermo = Format(pTCTempK, "###.#")
    Thermocouple_ljtia.Show
    
    
ErrorMessage:
    errorFunction Err.Number, strError

End Sub



Private Sub Form_Load()
    
    On Error GoTo ErrorMessage
        
    'Passing an 18 results in resolution equal to 18 for UE9 Pro but 17 for the regular UE9
    ainResolution = 18
    
    'Offset calibration:  The nominal voltage offset of the LJTick is
    '0.4 volts.  For improved accuracy, though, you should measure the
    'overall system offset.  We know that if the end of the TC is at the
    'same temperature as the cold junction, the voltage should be zero.
    'Put the end of the TC near the LJTIA to make sure they are at the same
    'temperature, and note the voltage measured by AIN0.  This is the actual
    'offset that can be entered below.  With a direct thermocouple to AINx
    'connection (no LJTIA), the offset will be closer to 0.0 volts.
    offSetVoltage = 0.4   ' 0.0
    
    'External Gain:  The UE9 does not know about any external gain, so to
    'determine the thermocouple voltage we need to divide the UE9 voltage
    'by any external gain.  In this example we assume the LJTIA is set to
    'a gain of x51.  If you are not using the LJTIA and have no external
    'gain then set this to 1.
    externalGain = 51
    
    'Channel which the TC/LJTIA is on (AIN0 equates to lngChannel = 0)
    lngChannel = 0
    
    TCType = LJ_ttK
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Set the resolution to ainResolution
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, ainResolution, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set the range on the analog input channel to 0-2.5 volts, which
    'is ideal for the LJTIA output.  The UE9-Pro does not support this
    'range but will automatically use 0-5 volts.  If using a normal
    'UE9 without the LJTIA, the 0-1.25 volt range provides slightly
    'better performance.
    lngError = eGet(lngHandle, LJ_ioPUT_AIN_RANGE, lngChannel, LJ_rgUNI2P5V, 0) 'LJ_rgUNI1P25V
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get a reading from AIN0.
    lngError = eGet(lngHandle, LJ_ioGET_AIN, lngChannel, dblAIN, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Acquire the internal temperature sensor reading.  This example uses
    'that value for cold junction compensation.
    lngError = eGet(lngHandle, LJ_ioGET_AIN, 133, dblInternal, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'To get the thermocouple voltage we subtract the offset from the AIN
    'voltage and divide by the LJTIA gain.
    TCVolts = (dblAIN - offSetVoltage) / externalGain
    
    lngError = TCVoltsToTemp(TCType, TCVolts, dblInternal, pTCTempK)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Display the results
    txtAIN0 = Format(dblAIN, "#.#####")
    txtInternal = Format(dblInternal, "###.#")
    txtThermo = Format(pTCTempK, "###.#")
    Thermocouple_ljtia.Show
    
    
'Simple error message function
ErrorMessage:
    errorFunction Err.Number, strError

End Sub

