VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   510
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   510
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox millisecondsDisplay 
      Height          =   285
      Left            =   2160
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
   Begin VB.Label millisecondsLabel 
      Caption         =   "Milliseconds Per Iteration:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  Demonstrates using the add/go/get method to efficiently write and read
'  some or all analog and digital I/O on the LabJack U3.
'  Records the time for 1000 iterations and divides by 1000, to allow
'  verification of the basic command/response communication times of the
'  LabJack UE9 as documented in Section 3.1 of the U3 User's Guide.
'
'  support@labjack.com
'  Jul 1, 2009
'----------------------------------------------------------------------
'

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngHandle As Long
    lngHandle = 0
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim lngChannel As Long
    lngChannel = 0
    Dim dblValue As Double
    dblValue = 0
    Dim ValueDIPort As Double
    ValueDIPort = 0
    Dim ValueAIN(16) As Double
    Dim time As Long
    time = 0
    Dim numIterations As Long
    numIterations = 1000
    Dim numChannels As Long
    numChannels = 5
    Dim ainResolution As Long
    ainResolution = 12
    Dim strError As String
    Dim i, j As Integer
    Dim dacVal As Integer
    Dim AOVal3, AOVal4 As Double
    Dim Ch As Long

    'Open the first found LabJack UE9.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000

    time = GetTickCount()

    For i = 0 To numIterations - 1
    
        For Ch = 0 To 12
            lngError = AddRequest(lngHandle, LJ_ioGET_AIN, Ch, 0, 0, 0)
        Next Ch
        
        lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTDAC_SCL_PIN_NUM, 0, 0, 0)
        lngError = AddRequest(lngHandle, LJ_ioTDAC_COMMUNICATION, LJ_chTDAC_UPDATE_DACA, AOVal3, 0, 0)
        lngError = AddRequest(lngHandle, LJ_ioTDAC_COMMUNICATION, LJ_chTDAC_UPDATE_DACB, AOVal4, 0, 0)

        'Execute the requests.
        lngError = GoOne(lngHandle)
        If lngError <> 0 Then Err.Raise lngError + 50000

        'Get all the results.  The input measurement results are stored.  All other
        'results are for configuration or output requests so we are just checking
        'whether there was an error.
        lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> 0 Then
            MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000)
        End If
        
        For Ch = 0 To 13
            lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
            If lngError <> 0 Then
                MsgBox "Function returned LabJackUD Error #" & _
                Str$(Err.Number - 50000)
            End If
        Next Ch
        
    Next i

    time = GetTickCount() - time

    millisecondsDisplay.Text = (time / numIterations)

ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
